<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAuthenticateUser.ContactInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAuthenticateUser.ContactInfo
 * @subpackage Arrays
 */
class ArrayOfAuthenticateUser_ContactInfo extends AbstractStructArrayBase
{
    /**
     * The AuthenticateUser_ContactInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AuthenticateUser_ContactInfo[]
     */
    public $AuthenticateUser_ContactInfo;
    /**
     * Constructor method for ArrayOfAuthenticateUser.ContactInfo
     * @uses ArrayOfAuthenticateUser_ContactInfo::setAuthenticateUser_ContactInfo()
     * @param \StructType\AuthenticateUser_ContactInfo[] $authenticateUser_ContactInfo
     */
    public function __construct(array $authenticateUser_ContactInfo = array())
    {
        $this
            ->setAuthenticateUser_ContactInfo($authenticateUser_ContactInfo);
    }
    /**
     * Get AuthenticateUser_ContactInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AuthenticateUser_ContactInfo[]|null
     */
    public function getAuthenticateUser_ContactInfo()
    {
        return isset($this->{'AuthenticateUser.ContactInfo'}) ? $this->{'AuthenticateUser.ContactInfo'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAuthenticateUser_ContactInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAuthenticateUser_ContactInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAuthenticateUser_ContactInfoForArrayConstraintsFromSetAuthenticateUser_ContactInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem instanceof \StructType\AuthenticateUser_ContactInfo) {
                $invalidValues[] = is_object($arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem) ? get_class($arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem) : sprintf('%s(%s)', gettype($arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem), var_export($arrayOfAuthenticateUser_ContactInfoAuthenticateUser_ContactInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AuthenticateUser_ContactInfo property can only contain items of type \StructType\AuthenticateUser_ContactInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AuthenticateUser_ContactInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_ContactInfo[] $authenticateUser_ContactInfo
     * @return \ArrayType\ArrayOfAuthenticateUser_ContactInfo
     */
    public function setAuthenticateUser_ContactInfo(array $authenticateUser_ContactInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($authenticateUser_ContactInfoArrayErrorMessage = self::validateAuthenticateUser_ContactInfoForArrayConstraintsFromSetAuthenticateUser_ContactInfo($authenticateUser_ContactInfo))) {
            throw new \InvalidArgumentException($authenticateUser_ContactInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($authenticateUser_ContactInfo) || (is_array($authenticateUser_ContactInfo) && empty($authenticateUser_ContactInfo))) {
            unset($this->AuthenticateUser_ContactInfo, $this->{'AuthenticateUser.ContactInfo'});
        } else {
            $this->AuthenticateUser_ContactInfo = $this->{'AuthenticateUser.ContactInfo'} = $authenticateUser_ContactInfo;
        }
        return $this;
    }
    /**
     * Add item to AuthenticateUser_ContactInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_ContactInfo $item
     * @return \ArrayType\ArrayOfAuthenticateUser_ContactInfo
     */
    public function addToAuthenticateUser_ContactInfo(\StructType\AuthenticateUser_ContactInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AuthenticateUser_ContactInfo) {
            throw new \InvalidArgumentException(sprintf('The AuthenticateUser_ContactInfo property can only contain items of type \StructType\AuthenticateUser_ContactInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AuthenticateUser_ContactInfo[] = $this->{'AuthenticateUser.ContactInfo'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AuthenticateUser_ContactInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AuthenticateUser_ContactInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AuthenticateUser_ContactInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AuthenticateUser_ContactInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AuthenticateUser_ContactInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AuthenticateUser.ContactInfo
     */
    public function getAttributeName()
    {
        return 'AuthenticateUser.ContactInfo';
    }
}
