<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAuthenticateUser.GroupRight ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAuthenticateUser.GroupRight
 * @subpackage Arrays
 */
class ArrayOfAuthenticateUser_GroupRight extends AbstractStructArrayBase
{
    /**
     * The AuthenticateUser_GroupRight
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AuthenticateUser_GroupRight[]
     */
    public $AuthenticateUser_GroupRight;
    /**
     * Constructor method for ArrayOfAuthenticateUser.GroupRight
     * @uses ArrayOfAuthenticateUser_GroupRight::setAuthenticateUser_GroupRight()
     * @param \StructType\AuthenticateUser_GroupRight[] $authenticateUser_GroupRight
     */
    public function __construct(array $authenticateUser_GroupRight = array())
    {
        $this
            ->setAuthenticateUser_GroupRight($authenticateUser_GroupRight);
    }
    /**
     * Get AuthenticateUser_GroupRight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AuthenticateUser_GroupRight[]|null
     */
    public function getAuthenticateUser_GroupRight()
    {
        return isset($this->{'AuthenticateUser.GroupRight'}) ? $this->{'AuthenticateUser.GroupRight'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAuthenticateUser_GroupRight method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAuthenticateUser_GroupRight method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAuthenticateUser_GroupRightForArrayConstraintsFromSetAuthenticateUser_GroupRight(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem) {
            // validation for constraint: itemType
            if (!$arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem instanceof \StructType\AuthenticateUser_GroupRight) {
                $invalidValues[] = is_object($arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem) ? get_class($arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem) : sprintf('%s(%s)', gettype($arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem), var_export($arrayOfAuthenticateUser_GroupRightAuthenticateUser_GroupRightItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AuthenticateUser_GroupRight property can only contain items of type \StructType\AuthenticateUser_GroupRight, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AuthenticateUser_GroupRight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_GroupRight[] $authenticateUser_GroupRight
     * @return \ArrayType\ArrayOfAuthenticateUser_GroupRight
     */
    public function setAuthenticateUser_GroupRight(array $authenticateUser_GroupRight = array())
    {
        // validation for constraint: array
        if ('' !== ($authenticateUser_GroupRightArrayErrorMessage = self::validateAuthenticateUser_GroupRightForArrayConstraintsFromSetAuthenticateUser_GroupRight($authenticateUser_GroupRight))) {
            throw new \InvalidArgumentException($authenticateUser_GroupRightArrayErrorMessage, __LINE__);
        }
        if (is_null($authenticateUser_GroupRight) || (is_array($authenticateUser_GroupRight) && empty($authenticateUser_GroupRight))) {
            unset($this->AuthenticateUser_GroupRight, $this->{'AuthenticateUser.GroupRight'});
        } else {
            $this->AuthenticateUser_GroupRight = $this->{'AuthenticateUser.GroupRight'} = $authenticateUser_GroupRight;
        }
        return $this;
    }
    /**
     * Add item to AuthenticateUser_GroupRight value
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_GroupRight $item
     * @return \ArrayType\ArrayOfAuthenticateUser_GroupRight
     */
    public function addToAuthenticateUser_GroupRight(\StructType\AuthenticateUser_GroupRight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AuthenticateUser_GroupRight) {
            throw new \InvalidArgumentException(sprintf('The AuthenticateUser_GroupRight property can only contain items of type \StructType\AuthenticateUser_GroupRight, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AuthenticateUser_GroupRight[] = $this->{'AuthenticateUser.GroupRight'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AuthenticateUser_GroupRight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AuthenticateUser_GroupRight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AuthenticateUser_GroupRight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AuthenticateUser_GroupRight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AuthenticateUser_GroupRight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AuthenticateUser.GroupRight
     */
    public function getAttributeName()
    {
        return 'AuthenticateUser.GroupRight';
    }
}
