<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAuthenticateUser.UserGroup ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAuthenticateUser.UserGroup
 * @subpackage Arrays
 */
class ArrayOfAuthenticateUser_UserGroup extends AbstractStructArrayBase
{
    /**
     * The AuthenticateUser_UserGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AuthenticateUser_UserGroup[]
     */
    public $AuthenticateUser_UserGroup;
    /**
     * Constructor method for ArrayOfAuthenticateUser.UserGroup
     * @uses ArrayOfAuthenticateUser_UserGroup::setAuthenticateUser_UserGroup()
     * @param \StructType\AuthenticateUser_UserGroup[] $authenticateUser_UserGroup
     */
    public function __construct(array $authenticateUser_UserGroup = array())
    {
        $this
            ->setAuthenticateUser_UserGroup($authenticateUser_UserGroup);
    }
    /**
     * Get AuthenticateUser_UserGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AuthenticateUser_UserGroup[]|null
     */
    public function getAuthenticateUser_UserGroup()
    {
        return isset($this->{'AuthenticateUser.UserGroup'}) ? $this->{'AuthenticateUser.UserGroup'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAuthenticateUser_UserGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAuthenticateUser_UserGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAuthenticateUser_UserGroupForArrayConstraintsFromSetAuthenticateUser_UserGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem instanceof \StructType\AuthenticateUser_UserGroup) {
                $invalidValues[] = is_object($arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem) ? get_class($arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem) : sprintf('%s(%s)', gettype($arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem), var_export($arrayOfAuthenticateUser_UserGroupAuthenticateUser_UserGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AuthenticateUser_UserGroup property can only contain items of type \StructType\AuthenticateUser_UserGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AuthenticateUser_UserGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_UserGroup[] $authenticateUser_UserGroup
     * @return \ArrayType\ArrayOfAuthenticateUser_UserGroup
     */
    public function setAuthenticateUser_UserGroup(array $authenticateUser_UserGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($authenticateUser_UserGroupArrayErrorMessage = self::validateAuthenticateUser_UserGroupForArrayConstraintsFromSetAuthenticateUser_UserGroup($authenticateUser_UserGroup))) {
            throw new \InvalidArgumentException($authenticateUser_UserGroupArrayErrorMessage, __LINE__);
        }
        if (is_null($authenticateUser_UserGroup) || (is_array($authenticateUser_UserGroup) && empty($authenticateUser_UserGroup))) {
            unset($this->AuthenticateUser_UserGroup, $this->{'AuthenticateUser.UserGroup'});
        } else {
            $this->AuthenticateUser_UserGroup = $this->{'AuthenticateUser.UserGroup'} = $authenticateUser_UserGroup;
        }
        return $this;
    }
    /**
     * Add item to AuthenticateUser_UserGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\AuthenticateUser_UserGroup $item
     * @return \ArrayType\ArrayOfAuthenticateUser_UserGroup
     */
    public function addToAuthenticateUser_UserGroup(\StructType\AuthenticateUser_UserGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AuthenticateUser_UserGroup) {
            throw new \InvalidArgumentException(sprintf('The AuthenticateUser_UserGroup property can only contain items of type \StructType\AuthenticateUser_UserGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AuthenticateUser_UserGroup[] = $this->{'AuthenticateUser.UserGroup'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AuthenticateUser_UserGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AuthenticateUser_UserGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AuthenticateUser_UserGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AuthenticateUser_UserGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AuthenticateUser_UserGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AuthenticateUser.UserGroup
     */
    public function getAttributeName()
    {
        return 'AuthenticateUser.UserGroup';
    }
}
