<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AuthenticateUser' => '\\StructType\\AuthenticateUser',
            'AuthenticateUserResponse' => '\\StructType\\AuthenticateUserResponse',
            'ChangeUserPassword' => '\\StructType\\ChangeUserPassword',
            'ChangeUserPasswordResponse' => '\\StructType\\ChangeUserPasswordResponse',
            'ForgottenUserPassword' => '\\StructType\\ForgottenUserPassword',
            'ForgottenUserPasswordResponse' => '\\StructType\\ForgottenUserPasswordResponse',
            'CheckUserNameAvailability' => '\\StructType\\CheckUserNameAvailability',
            'CheckUserNameAvailabilityResponse' => '\\StructType\\CheckUserNameAvailabilityResponse',
            'ValidateUser' => '\\StructType\\ValidateUser',
            'ValidateUserResponse' => '\\StructType\\ValidateUserResponse',
            'UserNameAvailability' => '\\StructType\\UserNameAvailability',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'AuthenticateUser.UserInfo' => '\\StructType\\AuthenticateUser_UserInfo',
            'ArrayOfAuthenticateUser.UserGroup' => '\\ArrayType\\ArrayOfAuthenticateUser_UserGroup',
            'AuthenticateUser.UserGroup' => '\\StructType\\AuthenticateUser_UserGroup',
            'ArrayOfAuthenticateUser.GroupRight' => '\\ArrayType\\ArrayOfAuthenticateUser_GroupRight',
            'AuthenticateUser.GroupRight' => '\\StructType\\AuthenticateUser_GroupRight',
            'ArrayOfAuthenticateUser.UserPrivilege' => '\\ArrayType\\ArrayOfAuthenticateUser_UserPrivilege',
            'AuthenticateUser.UserPrivilege' => '\\StructType\\AuthenticateUser_UserPrivilege',
            'AuthenticateUser.AgencyInfo' => '\\StructType\\AuthenticateUser_AgencyInfo',
            'ArrayOfAuthenticateUser.Commission' => '\\ArrayType\\ArrayOfAuthenticateUser_Commission',
            'AuthenticateUser.Commission' => '\\StructType\\AuthenticateUser_Commission',
            'ArrayOfAuthenticateUser.ContactInfo' => '\\ArrayType\\ArrayOfAuthenticateUser_ContactInfo',
            'AuthenticateUser.ContactInfo' => '\\StructType\\AuthenticateUser_ContactInfo',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'EmailAddressInfo' => '\\StructType\\EmailAddressInfo',
            'UserNameInfo' => '\\StructType\\UserNameInfo',
        );
    }
}
