<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuthenticateUser.UserGroup StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AuthenticateUser.UserGroup
 * @subpackage Structs
 */
class AuthenticateUser_UserGroup extends AbstractStructBase
{
    /**
     * The GroupName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GroupName;
    /**
     * The GroupRights
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAuthenticateUser_GroupRight
     */
    public $GroupRights;
    /**
     * Constructor method for AuthenticateUser.UserGroup
     * @uses AuthenticateUser_UserGroup::setGroupName()
     * @uses AuthenticateUser_UserGroup::setGroupRights()
     * @param string $groupName
     * @param \ArrayType\ArrayOfAuthenticateUser_GroupRight $groupRights
     */
    public function __construct($groupName = null, \ArrayType\ArrayOfAuthenticateUser_GroupRight $groupRights = null)
    {
        $this
            ->setGroupName($groupName)
            ->setGroupRights($groupRights);
    }
    /**
     * Get GroupName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGroupName()
    {
        return isset($this->GroupName) ? $this->GroupName : null;
    }
    /**
     * Set GroupName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $groupName
     * @return \StructType\AuthenticateUser_UserGroup
     */
    public function setGroupName($groupName = null)
    {
        // validation for constraint: string
        if (!is_null($groupName) && !is_string($groupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($groupName, true), gettype($groupName)), __LINE__);
        }
        if (is_null($groupName) || (is_array($groupName) && empty($groupName))) {
            unset($this->GroupName);
        } else {
            $this->GroupName = $groupName;
        }
        return $this;
    }
    /**
     * Get GroupRights value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAuthenticateUser_GroupRight|null
     */
    public function getGroupRights()
    {
        return isset($this->GroupRights) ? $this->GroupRights : null;
    }
    /**
     * Set GroupRights value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAuthenticateUser_GroupRight $groupRights
     * @return \StructType\AuthenticateUser_UserGroup
     */
    public function setGroupRights(\ArrayType\ArrayOfAuthenticateUser_GroupRight $groupRights = null)
    {
        if (is_null($groupRights) || (is_array($groupRights) && empty($groupRights))) {
            unset($this->GroupRights);
        } else {
            $this->GroupRights = $groupRights;
        }
        return $this;
    }
}
